/*
 * board/cmx300/gpio.h
 *
 * GPIO for the CompuLab CM-X300 module
 *
 * (C) Copyright 2009
 * Yulia Vilensky, CompuLab, vilensky@compulab.co.il
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef __CM_X300_GPIO__
#define __CM_X300_GPIO__

#ifdef CONFIG_CPU_MONAHANS

#include <asm/arch/hardware.h>
#include "cmx300_common.h"

/*
 * These macros in pxa-regs.h are wrong for both of pxa300 & pxa310.
 *
 */

#define _GPLR(x)	__REG2(0x40E00000, ((x) & 0x60) >> 3)
#define _GPDR(x)	__REG2(0x40E0000C, ((x) & 0x60) >> 3)
#define _GPSR(x)	__REG2(0x40E00018, ((x) & 0x60) >> 3)
#define _GPCR(x)	__REG2(0x40E00024, ((x) & 0x60) >> 3)
#define _GRER(x)	__REG2(0x40E00030, ((x) & 0x60) >> 3)
#define _GFER(x)	__REG2(0x40E0003C, ((x) & 0x60) >> 3)
#define _GEDR(x)	__REG2(0x40E00048, ((x) & 0x60) >> 3)

#define CMX300_GPLR(x)		(*((((x) & 0x7f) < 96) ? &_GPLR(x) : &GPLR3))
#define CMX300_GPDR(x)		(*((((x) & 0x7f) < 96) ? &_GPDR(x) : &GPDR3))
#define CMX300_GPSR(x)		(*((((x) & 0x7f) < 96) ? &_GPSR(x) : &GPSR3))
#define CMX300_GPCR(x)		(*((((x) & 0x7f) < 96) ? &_GPCR(x) : &GPCR3))
#define CMX300_GRER(x)		(*((((x) & 0x7f) < 96) ? &_GRER(x) : &GRER3))
#define CMX300_GFER(x)		(*((((x) & 0x7f) < 96) ? &_GFER(x) : &GFER3))
#define CMX300_GEDR(x)		(*((((x) & 0x7f) < 96) ? &_GEDR(x) : &GEDR3))

int set_user_gpios(void);

#endif /* CONFIG_CPU_MONAHANS */
#endif /* __CM_X300_GPIO__ */
